--------------------------------------------------------------------------------
-- Company: UNIVERSITY OF CONNECTICUT
-- Engineer: Farrukh Hijaz
--
-- Create Date:    10/07/2014
-- Design Name:    
-- Module Name:    wb_kb_read_sram_write - Behavioral
-- Project Name:   
-- Target Device:  
-- Tool versions:  
-- Description:
--
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
--------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity wb_kb_read_sram_write is
	Port ( 	clk_i: 	in 		std_logic;
			rst_i: 	in 		std_logic;
		    adr_o: 	out 	std_logic_vector(31 downto 0);
			dat_i: 	in 		std_logic_vector(31 downto 0);
			dat_o: 	out 	std_logic_vector(31 downto 0);
			ack_i: 	in 		std_logic;
			cyc_o: 	out 	std_logic;
			stb_o: 	out 	std_logic;
			we_o: 	out 	std_logic;
			irq_i: 	in 		std_logic;
			leds_o:	out 	std_logic_vector(7 downto 0);
			irqv_i: in 		std_logic_vector(1 downto 0);
			head:	inout	std_logic_vector(23 downto 0);
			);
end wb_kb_read_sram_write;

architecture Behavioral of wb_kb_read_sram_write is
	signal code, ascii : std_logic_vector(7 downto 0);
	signal shift, ctrl, alt : std_logic;
begin

	-- convert the scancode signal given the shift, ctrl, and alt flags into
	-- an eight bit ASCII signal.
	s2a : entity work.scancode2ascii
		port map ( scancode => code,
						ascii => ascii,
						shift => shift,
						ctrl => ctrl,
						alt => alt );

	

end Behavioral;
